// implementing v3d
#include "stdafx.h"
#include "v3d.h"
#include "math.h"

v3d::v3d()
{
	x=0.0f; y=0.0f; z=0.0f;
}
v3d::v3d(GLfloat xf,GLfloat yf,GLfloat zf)
{
	x=xf; y=yf; z=zf;
}
v3d::~v3d()
{
}

void v3d::cross(v3d w)
{
	//C=AxB=(a2b3-a3b2, a3b1-a1b3, a1b2-a2b1)
	GLfloat newx,newy,newz;
	newx=y*w.z-z*w.y;
	newy=z*w.x-x*w.z;
	newz=x*w.y-y*w.x;
	x=newx;
	y=newy;
	z=newz;
}

void v3d::cross(GLfloat wx,GLfloat wy,GLfloat wz)
{
	//C=AxB=(a2b3-a3b2, a3b1-a1b3, a1b2-a2b1)
	GLfloat newx,newy,newz;
	newx=y*wz-z*wy;
	newy=z*wx-x*wz;
	newz=x*wy-y*wx;
	x=newx;
	y=newy;
	z=newz;
}


void v3d::normalize()
{
	GLfloat L=(float)sqrt(x*x+y*y+z*z);
	x=x/L;
	y=y/L;
	z=z/L;
}